diff --git a/meson.build b/meson.build
index d7c5193d4ce..4972c7b26d4 100644
--- a/meson.build
+++ b/meson.build
@@ -751,81 +751,81 @@ endif
 
 ldapopt = get_option('ldap')
 if ldapopt.disabled()
-  ldap = not_found_dep
-  ldap_r = not_found_dep
+	ldap = not_found_dep
+	ldap_r = not_found_dep
 elif host_system == 'windows'
-  ldap = cc.find_library('wldap32', required: ldapopt)
-  ldap_r = ldap
+	ldap = cc.find_library('wldap32', required: ldapopt)
+	ldap_r = ldap
 else
-  # macos framework dependency is buggy for ldap (one can argue whether it's
-  # Apple's or meson's fault), leading to an endless recursion with ldap.h
-  # including itself. See https://github.com/mesonbuild/meson/issues/10002
-  # Luckily we only need pkg-config support, so the workaround isn't
-  # complicated.
-  ldap = dependency('ldap', method: 'pkg-config', required: false)
-  ldap_r = ldap
-
-  # Before 2.5 openldap didn't have a pkg-config file, and it might not be
-  # installed
-  if not ldap.found()
-    ldap = cc.find_library('ldap', required: ldapopt, dirs: test_lib_d,
-      has_headers: 'ldap.h', header_include_directories: postgres_inc)
-
-    # The separate ldap_r library only exists in OpenLDAP < 2.5, and if we
-    # have 2.5 or later, we shouldn't even probe for ldap_r (we might find a
-    # library from a separate OpenLDAP installation).  The most reliable
-    # way to check that is to check for a function introduced in 2.5.
-    if not ldap.found()
-      # don't have ldap, we shouldn't check for ldap_r
-    elif cc.has_function('ldap_verify_credentials',
-        dependencies: ldap, args: test_c_args)
-      ldap_r = ldap # ldap >= 2.5, no need for ldap_r
-    else
-
-      # Use ldap_r for FE if available, else assume ldap is thread-safe.
-      ldap_r = cc.find_library('ldap_r', required: false, dirs: test_lib_d,
-        has_headers: 'ldap.h', header_include_directories: postgres_inc)
-      if not ldap_r.found()
-        ldap_r = ldap
-      else
-        # On some platforms ldap_r fails to link without PTHREAD_LIBS.
-        ldap_r = declare_dependency(dependencies: [ldap_r, thread_dep])
-      endif
-
-      # PostgreSQL sometimes loads libldap_r and plain libldap into the same
-      # process.  Check for OpenLDAP versions known not to tolerate doing so;
-      # assume non-OpenLDAP implementations are safe.  The dblink test suite
-      # exercises the hazardous interaction directly.
-      compat_test_code = '''
+	# macos framework dependency is buggy for ldap (one can argue whether it's
+	# Apple's or meson's fault), leading to an endless recursion with ldap.h
+	# including itself. See https://github.com/mesonbuild/meson/issues/10002
+	# Luckily we only need pkg-config support, so the workaround isn't
+	# complicated.
+	ldap = dependency('ldap', method: 'pkg-config', required: false)
+	ldap_r = ldap
+
+	# Before 2.5 openldap didn't have a pkg-config file, and it might not be
+	# installed
+	if not ldap.found()
+		ldap = cc.find_library('ldap', required: ldapopt, dirs: test_lib_d,
+			has_headers: 'ldap.h', header_include_directories: postgres_inc)
+
+		# The separate ldap_r library only exists in OpenLDAP < 2.5, and if we
+		# have 2.5 or later, we shouldn't even probe for ldap_r (we might find a
+		# library from a separate OpenLDAP installation).  The most reliable
+		# way to check that is to check for a function introduced in 2.5.
+		if not ldap.found()
+			# don't have ldap, we shouldn't check for ldap_r
+		elif cc.has_function('ldap_verify_credentials',
+				dependencies: ldap, args: test_c_args)
+			ldap_r = ldap # ldap >= 2.5, no need for ldap_r
+		else
+
+			# Use ldap_r for FE if available, else assume ldap is thread-safe.
+			ldap_r = cc.find_library('ldap_r', required: false, dirs: test_lib_d,
+				has_headers: 'ldap.h', header_include_directories: postgres_inc)
+			if not ldap_r.found()
+				ldap_r = ldap
+			else
+				# On some platforms ldap_r fails to link without PTHREAD_LIBS.
+				ldap_r = declare_dependency(dependencies: [ldap_r, thread_dep])
+			endif
+
+			# PostgreSQL sometimes loads libldap_r and plain libldap into the same
+			# process.  Check for OpenLDAP versions known not to tolerate doing so;
+			# assume non-OpenLDAP implementations are safe.  The dblink test suite
+			# exercises the hazardous interaction directly.
+			compat_test_code = '''
 #include <ldap.h>
 #if !defined(LDAP_VENDOR_VERSION) || \
-     (defined(LDAP_API_FEATURE_X_OPENLDAP) && \
-      LDAP_VENDOR_VERSION >= 20424 && LDAP_VENDOR_VERSION <= 20431)
+		 (defined(LDAP_API_FEATURE_X_OPENLDAP) && \
+			LDAP_VENDOR_VERSION >= 20424 && LDAP_VENDOR_VERSION <= 20431)
 choke me
 #endif
 '''
-      if not cc.compiles(compat_test_code,
-          name: 'LDAP implementation compatible',
-          dependencies: ldap, args: test_c_args)
-        warning('''
+			if not cc.compiles(compat_test_code,
+					name: 'LDAP implementation compatible',
+					dependencies: ldap, args: test_c_args)
+				warning('''
 *** With OpenLDAP versions 2.4.24 through 2.4.31, inclusive, each backend
 *** process that loads libpq (via WAL receiver, dblink, or postgres_fdw) and
 *** also uses LDAP will crash on exit.''')
-      endif
-    endif
-  endif
+			endif
+		endif
+	endif
 
-  if ldap.found() and cc.has_function('ldap_initialize',
-      dependencies: ldap, args: test_c_args)
-    cdata.set('HAVE_LDAP_INITIALIZE', 1)
-  endif
+	if ldap.found() and cc.has_function('ldap_initialize',
+			dependencies: ldap, args: test_c_args)
+		cdata.set('HAVE_LDAP_INITIALIZE', 1)
+	endif
 endif
 
 if ldap.found()
-  assert(ldap_r.found())
-  cdata.set('USE_LDAP', 1)
+	assert(ldap_r.found())
+	cdata.set('USE_LDAP', 1)
 else
-  assert(not ldap_r.found())
+	assert(not ldap_r.found())
 endif
 
 
@@ -837,24 +837,24 @@ endif
 llvmopt = get_option('llvm')
 llvm = not_found_dep
 if add_languages('cpp', required: llvmopt, native: false)
-  llvm = dependency('llvm', version: '>=14', method: 'config-tool', required: llvmopt)
+	llvm = dependency('llvm', version: '>=14', method: 'config-tool', required: llvmopt)
 
-  if llvm.found()
+	if llvm.found()
 
-    cdata.set('USE_LLVM', 1)
+		cdata.set('USE_LLVM', 1)
 
-    cpp = meson.get_compiler('cpp')
+		cpp = meson.get_compiler('cpp')
 
-    llvm_binpath = llvm.get_variable(configtool: 'bindir')
+		llvm_binpath = llvm.get_variable(configtool: 'bindir')
 
-    ccache = find_program('ccache', native: true, required: false)
+		ccache = find_program('ccache', native: true, required: false)
 
-    # Some distros put LLVM and clang in different paths, so fallback to
-    # find via PATH, too.
-    clang = find_program(llvm_binpath / 'clang', 'clang', required: true)
-  endif
+		# Some distros put LLVM and clang in different paths, so fallback to
+		# find via PATH, too.
+		clang = find_program(llvm_binpath / 'clang', 'clang', required: true)
+	endif
 elif llvmopt.auto()
-  message('llvm requires a C++ compiler')
+	message('llvm requires a C++ compiler')
 endif
 
 
@@ -865,30 +865,30 @@ endif
 
 icuopt = get_option('icu')
 if not icuopt.disabled()
-  icu = dependency('icu-uc', required: false)
-  if icu.found()
-    icu_i18n = dependency('icu-i18n', required: true)
-  endif
-
-  # Unfortunately the dependency is named differently with cmake
-  if not icu.found() # combine with above once meson 0.60.0 is required
-    icu = dependency('ICU', required: icuopt,
-                     components: ['uc'], modules: ['ICU::uc'], method: 'cmake')
-    if icu.found()
-      icu_i18n = dependency('ICU', required: true,
-                            components: ['i18n'], modules: ['ICU::i18n'])
-    endif
-  endif
-
-  if icu.found()
-    cdata.set('USE_ICU', 1)
-  else
-    icu_i18n = not_found_dep
-  endif
+	icu = dependency('icu-uc', required: false)
+	if icu.found()
+		icu_i18n = dependency('icu-i18n', required: true)
+	endif
+
+	# Unfortunately the dependency is named differently with cmake
+	if not icu.found() # combine with above once meson 0.60.0 is required
+		icu = dependency('ICU', required: icuopt,
+										 components: ['uc'], modules: ['ICU::uc'], method: 'cmake')
+		if icu.found()
+			icu_i18n = dependency('ICU', required: true,
+														components: ['i18n'], modules: ['ICU::i18n'])
+		endif
+	endif
+
+	if icu.found()
+		cdata.set('USE_ICU', 1)
+	else
+		icu_i18n = not_found_dep
+	endif
 
 else
-  icu = not_found_dep
-  icu_i18n = not_found_dep
+	icu = not_found_dep
+	icu_i18n = not_found_dep
 endif
 
 
@@ -901,99 +901,99 @@ libcurlopt = get_option('libcurl')
 oauth_flow_supported = false
 
 if not libcurlopt.disabled()
-  # Check for libcurl 7.61.0 or higher (corresponding to RHEL8 and the ability
-  # to explicitly set TLS 1.3 ciphersuites).
-  libcurl = dependency('libcurl', version: '>= 7.61.0', required: libcurlopt)
-  if libcurl.found()
-    # Check to see whether the current platform supports thread-safe Curl
-    # initialization.
-    libcurl_threadsafe_init = false
-
-    if not meson.is_cross_build()
-      r = cc.run('''
-        #include <curl/curl.h>
-
-        int main(void)
-        {
-            curl_version_info_data *info;
-
-            if (curl_global_init(CURL_GLOBAL_ALL))
-                return -1;
-
-            info = curl_version_info(CURLVERSION_NOW);
-        #ifdef CURL_VERSION_THREADSAFE
-            if (info->features & CURL_VERSION_THREADSAFE)
-                return 0;
-        #endif
-
-            return 1;
-        }''',
-        name: 'test for curl_global_init thread safety',
-        dependencies: libcurl,
-      )
-
-      assert(r.compiled())
-      if r.returncode() == 0
-        libcurl_threadsafe_init = true
-        message('curl_global_init is thread-safe')
-      elif r.returncode() == 1
-        message('curl_global_init is not thread-safe')
-      else
-        message('curl_global_init failed; assuming not thread-safe')
-      endif
-    endif
-
-    if libcurl_threadsafe_init
-      cdata.set('HAVE_THREADSAFE_CURL_GLOBAL_INIT', 1)
-    endif
-
-    # Fail if a thread-friendly DNS resolver isn't built.
-    if not meson.is_cross_build()
-      r = cc.run('''
-        #include <curl/curl.h>
-
-        int main(void)
-        {
-            curl_version_info_data *info;
-
-            if (curl_global_init(CURL_GLOBAL_ALL))
-                return -1;
-
-            info = curl_version_info(CURLVERSION_NOW);
-            return (info->features & CURL_VERSION_ASYNCHDNS) ? 0 : 1;
-        }''',
-        name: 'test for curl support for asynchronous DNS',
-        dependencies: libcurl,
-      )
-
-      assert(r.compiled())
-      if r.returncode() != 0
-        error('''
+	# Check for libcurl 7.61.0 or higher (corresponding to RHEL8 and the ability
+	# to explicitly set TLS 1.3 ciphersuites).
+	libcurl = dependency('libcurl', version: '>= 7.61.0', required: libcurlopt)
+	if libcurl.found()
+		# Check to see whether the current platform supports thread-safe Curl
+		# initialization.
+		libcurl_threadsafe_init = false
+
+		if not meson.is_cross_build()
+			r = cc.run('''
+				#include <curl/curl.h>
+
+				int main(void)
+				{
+						curl_version_info_data *info;
+
+						if (curl_global_init(CURL_GLOBAL_ALL))
+								return -1;
+
+						info = curl_version_info(CURLVERSION_NOW);
+				#ifdef CURL_VERSION_THREADSAFE
+						if (info->features & CURL_VERSION_THREADSAFE)
+								return 0;
+				#endif
+
+						return 1;
+				}''',
+				name: 'test for curl_global_init thread safety',
+				dependencies: libcurl,
+			)
+
+			assert(r.compiled())
+			if r.returncode() == 0
+				libcurl_threadsafe_init = true
+				message('curl_global_init is thread-safe')
+			elif r.returncode() == 1
+				message('curl_global_init is not thread-safe')
+			else
+				message('curl_global_init failed; assuming not thread-safe')
+			endif
+		endif
+
+		if libcurl_threadsafe_init
+			cdata.set('HAVE_THREADSAFE_CURL_GLOBAL_INIT', 1)
+		endif
+
+		# Fail if a thread-friendly DNS resolver isn't built.
+		if not meson.is_cross_build()
+			r = cc.run('''
+				#include <curl/curl.h>
+
+				int main(void)
+				{
+						curl_version_info_data *info;
+
+						if (curl_global_init(CURL_GLOBAL_ALL))
+								return -1;
+
+						info = curl_version_info(CURLVERSION_NOW);
+						return (info->features & CURL_VERSION_ASYNCHDNS) ? 0 : 1;
+				}''',
+				name: 'test for curl support for asynchronous DNS',
+				dependencies: libcurl,
+			)
+
+			assert(r.compiled())
+			if r.returncode() != 0
+				error('''
 *** The installed version of libcurl does not support asynchronous DNS
 *** lookups. Rebuild libcurl with the AsynchDNS feature enabled in order
 *** to use it with libpq.''')
-      endif
-    endif
-  endif
-
-  # Check that the current platform supports our builtin flow. This requires
-  # libcurl and one of either epoll or kqueue.
-  oauth_flow_supported = (
-    libcurl.found()
-    and (cc.has_header('sys/event.h',
-                       args: test_c_args, include_directories: postgres_inc)
-         or cc.has_header('sys/epoll.h',
-                          args: test_c_args, include_directories: postgres_inc))
-  )
-
-  if oauth_flow_supported
-    cdata.set('USE_LIBCURL', 1)
-  elif libcurlopt.enabled()
-    error('client-side OAuth is not supported on this platform')
-  endif
+			endif
+		endif
+	endif
+
+	# Check that the current platform supports our builtin flow. This requires
+	# libcurl and one of either epoll or kqueue.
+	oauth_flow_supported = (
+		libcurl.found()
+		and (cc.has_header('sys/event.h',
+											 args: test_c_args, include_directories: postgres_inc)
+				 or cc.has_header('sys/epoll.h',
+													args: test_c_args, include_directories: postgres_inc))
+	)
+
+	if oauth_flow_supported
+		cdata.set('USE_LIBCURL', 1)
+	elif libcurlopt.enabled()
+		error('client-side OAuth is not supported on this platform')
+	endif
 
 else
-  libcurl = not_found_dep
+	libcurl = not_found_dep
 endif
 
 
@@ -1003,19 +1003,19 @@ endif
 
 libnumaopt = get_option('libnuma')
 if not libnumaopt.disabled()
-  # via pkg-config
-  libnuma = dependency('numa', required: false)
-  if not libnuma.found()
-    libnuma = cc.find_library('numa', required: libnumaopt)
-  endif
-  if not cc.has_header('numa.h', dependencies: libnuma, required: libnumaopt)
-    libnuma = not_found_dep
-  endif
-  if libnuma.found()
-    cdata.set('USE_LIBNUMA', 1)
-  endif
+	# via pkg-config
+	libnuma = dependency('numa', required: false)
+	if not libnuma.found()
+		libnuma = cc.find_library('numa', required: libnumaopt)
+	endif
+	if not cc.has_header('numa.h', dependencies: libnuma, required: libnumaopt)
+		libnuma = not_found_dep
+	endif
+	if libnuma.found()
+		cdata.set('USE_LIBNUMA', 1)
+	endif
 else
-  libnuma = not_found_dep
+	libnuma = not_found_dep
 endif
 
 
@@ -1026,12 +1026,12 @@ endif
 liburingopt = get_option('liburing')
 liburing = dependency('liburing', required: liburingopt)
 if liburing.found()
-  cdata.set('USE_LIBURING', 1)
+	cdata.set('USE_LIBURING', 1)
 
-  if cc.has_function('io_uring_queue_init_mem',
-      dependencies: liburing, args: test_c_args)
-    cdata.set('HAVE_LIBURING_QUEUE_INIT_MEM', 1)
-  endif
+	if cc.has_function('io_uring_queue_init_mem',
+			dependencies: liburing, args: test_c_args)
+		cdata.set('HAVE_LIBURING_QUEUE_INIT_MEM', 1)
+	endif
 
 endif
 
@@ -1043,18 +1043,18 @@ endif
 
 libxmlopt = get_option('libxml')
 if not libxmlopt.disabled()
-  libxml = dependency('libxml-2.0', required: false, version: '>= 2.6.23')
-  # Unfortunately the dependency is named differently with cmake
-  if not libxml.found() # combine with above once meson 0.60.0 is required
-    libxml = dependency('LibXml2', required: libxmlopt, version: '>= 2.6.23',
-      method: 'cmake')
-  endif
-
-  if libxml.found()
-    cdata.set('USE_LIBXML', 1)
-  endif
+	libxml = dependency('libxml-2.0', required: false, version: '>= 2.6.23')
+	# Unfortunately the dependency is named differently with cmake
+	if not libxml.found() # combine with above once meson 0.60.0 is required
+		libxml = dependency('LibXml2', required: libxmlopt, version: '>= 2.6.23',
+			method: 'cmake')
+	endif
+
+	if libxml.found()
+		cdata.set('USE_LIBXML', 1)
+	endif
 else
-  libxml = not_found_dep
+	libxml = not_found_dep
 endif
 
 
@@ -1065,17 +1065,17 @@ endif
 
 libxsltopt = get_option('libxslt')
 if not libxsltopt.disabled()
-  libxslt = dependency('libxslt', required: false)
-  # Unfortunately the dependency is named differently with cmake
-  if not libxslt.found() # combine with above once meson 0.60.0 is required
-    libxslt = dependency('LibXslt', required: libxsltopt, method: 'cmake')
-  endif
-
-  if libxslt.found()
-    cdata.set('USE_LIBXSLT', 1)
-  endif
+	libxslt = dependency('libxslt', required: false)
+	# Unfortunately the dependency is named differently with cmake
+	if not libxslt.found() # combine with above once meson 0.60.0 is required
+		libxslt = dependency('LibXslt', required: libxsltopt, method: 'cmake')
+	endif
+
+	if libxslt.found()
+		cdata.set('USE_LIBXSLT', 1)
+	endif
 else
-  libxslt = not_found_dep
+	libxslt = not_found_dep
 endif
 
 
@@ -1086,21 +1086,21 @@ endif
 
 lz4opt = get_option('lz4')
 if not lz4opt.disabled()
-  lz4 = dependency('liblz4', required: false)
-  # Unfortunately the dependency is named differently with cmake
-  if not lz4.found() # combine with above once meson 0.60.0 is required
-    lz4 = dependency('lz4', required: lz4opt,
-                     method: 'cmake', modules: ['LZ4::lz4_shared'],
-                    )
-  endif
-
-  if lz4.found()
-    cdata.set('USE_LZ4', 1)
-    cdata.set('HAVE_LIBLZ4', 1)
-  endif
+	lz4 = dependency('liblz4', required: false)
+	# Unfortunately the dependency is named differently with cmake
+	if not lz4.found() # combine with above once meson 0.60.0 is required
+		lz4 = dependency('lz4', required: lz4opt,
+										 method: 'cmake', modules: ['LZ4::lz4_shared'],
+										)
+	endif
+
+	if lz4.found()
+		cdata.set('USE_LZ4', 1)
+		cdata.set('HAVE_LIBLZ4', 1)
+	endif
 
 else
-  lz4 = not_found_dep
+	lz4 = not_found_dep
 endif
 
 
@@ -1119,18 +1119,18 @@ tcl_version = get_option('tcl_version')
 tcl_dep = not_found_dep
 if not tclopt.disabled()
 
-  # via pkg-config
-  tcl_dep = dependency(tcl_version, required: false)
+	# via pkg-config
+	tcl_dep = dependency(tcl_version, required: false)
 
-  if not tcl_dep.found()
-    tcl_dep = cc.find_library(tcl_version,
-      required: tclopt,
-      dirs: test_lib_d)
-  endif
+	if not tcl_dep.found()
+		tcl_dep = cc.find_library(tcl_version,
+			required: tclopt,
+			dirs: test_lib_d)
+	endif
 
-  if not cc.has_header('tcl.h', dependencies: tcl_dep, required: tclopt)
-    tcl_dep = not_found_dep
-  endif
+	if not cc.has_header('tcl.h', dependencies: tcl_dep, required: tclopt)
+		tcl_dep = not_found_dep
+	endif
 endif
 
 
@@ -1141,34 +1141,34 @@ endif
 
 pamopt = get_option('pam')
 if not pamopt.disabled()
-  pam = dependency('pam', required: false)
-
-  if not pam.found()
-    pam = cc.find_library('pam', required: pamopt, dirs: test_lib_d)
-  endif
-
-  if pam.found()
-    pam_header_found = false
-
-    # header file <security/pam_appl.h> or <pam/pam_appl.h> is required for PAM.
-    if cc.check_header('security/pam_appl.h', dependencies: pam, required: false,
-        args: test_c_args, include_directories: postgres_inc)
-      cdata.set('HAVE_SECURITY_PAM_APPL_H', 1)
-      pam_header_found = true
-    elif cc.check_header('pam/pam_appl.h', dependencies: pam, required: pamopt,
-        args: test_c_args, include_directories: postgres_inc)
-      cdata.set('HAVE_PAM_PAM_APPL_H', 1)
-      pam_header_found = true
-    endif
-
-    if pam_header_found
-      cdata.set('USE_PAM', 1)
-    else
-      pam = not_found_dep
-    endif
-  endif
+	pam = dependency('pam', required: false)
+
+	if not pam.found()
+		pam = cc.find_library('pam', required: pamopt, dirs: test_lib_d)
+	endif
+
+	if pam.found()
+		pam_header_found = false
+
+		# header file <security/pam_appl.h> or <pam/pam_appl.h> is required for PAM.
+		if cc.check_header('security/pam_appl.h', dependencies: pam, required: false,
+				args: test_c_args, include_directories: postgres_inc)
+			cdata.set('HAVE_SECURITY_PAM_APPL_H', 1)
+			pam_header_found = true
+		elif cc.check_header('pam/pam_appl.h', dependencies: pam, required: pamopt,
+				args: test_c_args, include_directories: postgres_inc)
+			cdata.set('HAVE_PAM_PAM_APPL_H', 1)
+			pam_header_found = true
+		endif
+
+		if pam_header_found
+			cdata.set('USE_PAM', 1)
+		else
+			pam = not_found_dep
+		endif
+	endif
 else
-  pam = not_found_dep
+	pam = not_found_dep
 endif
 
 
@@ -1181,88 +1181,88 @@ perlopt = get_option('plperl')
 perl_dep = not_found_dep
 perlversion = ''
 if not perlopt.disabled()
-  perl_may_work = true
-
-  # First verify that perl has the necessary dependencies installed
-  perl_mods = run_command(
-    [perl,
-     '-MConfig', '-MOpcode', '-MExtUtils::Embed', '-MExtUtils::ParseXS',
-     '-e', ''],
-    check: false)
-  if perl_mods.returncode() != 0
-    perl_may_work = false
-    perl_msg = 'perl installation does not have the required modules'
-  endif
-
-  # Then inquire perl about its configuration
-  if perl_may_work
-    perl_conf_cmd = [perl, '-MConfig', '-e', 'print $Config{$ARGV[0]}']
-    perlversion = run_command(perl_conf_cmd, 'version', check: true).stdout()
-    archlibexp = run_command(perl_conf_cmd, 'archlibexp', check: true).stdout()
-    privlibexp = run_command(perl_conf_cmd, 'privlibexp', check: true).stdout()
-    useshrplib = run_command(perl_conf_cmd, 'useshrplib', check: true).stdout()
-
-    perl_inc_dir = '@0@/CORE'.format(archlibexp)
-
-    if perlversion.version_compare('< 5.14')
-      perl_may_work = false
-      perl_msg = 'Perl version 5.14 or later is required, but this is @0@'.format(perlversion)
-    elif useshrplib != 'true'
-      perl_may_work = false
-      perl_msg = 'need a shared perl'
-    endif
-  endif
-
-  if perl_may_work
-    # On most platforms, archlibexp is also where the Perl include files live ...
-    perl_ccflags = ['-I@0@'.format(perl_inc_dir)]
-    # ... but on newer macOS versions, we must use -iwithsysroot to look
-    # under sysroot
-    if not fs.is_file('@0@/perl.h'.format(perl_inc_dir)) and \
-       fs.is_file('@0@@1@/perl.h'.format(pg_sysroot, perl_inc_dir))
-      perl_ccflags = ['-iwithsysroot', perl_inc_dir]
-    endif
-
-    # check compiler finds header
-    if not cc.has_header('perl.h', required: false,
-        args: test_c_args + perl_ccflags, include_directories: postgres_inc)
-      perl_may_work = false
-      perl_msg = 'missing perl.h'
-    endif
-  endif
-
-  if perl_may_work
-    perl_ccflags_r = run_command(perl_conf_cmd, 'ccflags', check: true).stdout()
-
-    # See comments for PGAC_CHECK_PERL_EMBED_CCFLAGS in perl.m4
-    foreach flag : perl_ccflags_r.split(' ')
-      if flag.startswith('-D') and \
-          (not flag.startswith('-D_') or flag == '_USE_32BIT_TIME_T')
-        perl_ccflags += flag
-      endif
-    endforeach
-
-    if host_system == 'windows'
-      perl_ccflags += ['-DPLPERL_HAVE_UID_GID']
-
-      if cc.get_id() == 'msvc'
-        # prevent binary mismatch between MSVC built plperl and Strawberry or
-        # msys ucrt perl libraries
-        perl_v = run_command(perl, '-V', check: false).stdout()
-        if not perl_v.contains('USE_THREAD_SAFE_LOCALE')
-          perl_ccflags += ['-DNO_THREAD_SAFE_LOCALE']
-        endif
-      endif
-    endif
-
-    message('CCFLAGS recommended by perl: @0@'.format(perl_ccflags_r))
-    message('CCFLAGS for embedding perl: @0@'.format(' '.join(perl_ccflags)))
-
-    # We are after Embed's ldopts, but without the subset mentioned in
-    # Config's ccdlflags and ldflags.  (Those are the choices of those who
-    # built the Perl installation, which are not necessarily appropriate
-    # for building PostgreSQL.)
-    perl_ldopts = run_command(perl, '-e', '''
+	perl_may_work = true
+
+	# First verify that perl has the necessary dependencies installed
+	perl_mods = run_command(
+		[perl,
+		 '-MConfig', '-MOpcode', '-MExtUtils::Embed', '-MExtUtils::ParseXS',
+		 '-e', ''],
+		check: false)
+	if perl_mods.returncode() != 0
+		perl_may_work = false
+		perl_msg = 'perl installation does not have the required modules'
+	endif
+
+	# Then inquire perl about its configuration
+	if perl_may_work
+		perl_conf_cmd = [perl, '-MConfig', '-e', 'print $Config{$ARGV[0]}']
+		perlversion = run_command(perl_conf_cmd, 'version', check: true).stdout()
+		archlibexp = run_command(perl_conf_cmd, 'archlibexp', check: true).stdout()
+		privlibexp = run_command(perl_conf_cmd, 'privlibexp', check: true).stdout()
+		useshrplib = run_command(perl_conf_cmd, 'useshrplib', check: true).stdout()
+
+		perl_inc_dir = '@0@/CORE'.format(archlibexp)
+
+		if perlversion.version_compare('< 5.14')
+			perl_may_work = false
+			perl_msg = 'Perl version 5.14 or later is required, but this is @0@'.format(perlversion)
+		elif useshrplib != 'true'
+			perl_may_work = false
+			perl_msg = 'need a shared perl'
+		endif
+	endif
+
+	if perl_may_work
+		# On most platforms, archlibexp is also where the Perl include files live ...
+		perl_ccflags = ['-I@0@'.format(perl_inc_dir)]
+		# ... but on newer macOS versions, we must use -iwithsysroot to look
+		# under sysroot
+		if not fs.is_file('@0@/perl.h'.format(perl_inc_dir)) and \
+			 fs.is_file('@0@@1@/perl.h'.format(pg_sysroot, perl_inc_dir))
+			perl_ccflags = ['-iwithsysroot', perl_inc_dir]
+		endif
+
+		# check compiler finds header
+		if not cc.has_header('perl.h', required: false,
+				args: test_c_args + perl_ccflags, include_directories: postgres_inc)
+			perl_may_work = false
+			perl_msg = 'missing perl.h'
+		endif
+	endif
+
+	if perl_may_work
+		perl_ccflags_r = run_command(perl_conf_cmd, 'ccflags', check: true).stdout()
+
+		# See comments for PGAC_CHECK_PERL_EMBED_CCFLAGS in perl.m4
+		foreach flag : perl_ccflags_r.split(' ')
+			if flag.startswith('-D') and \
+					(not flag.startswith('-D_') or flag == '_USE_32BIT_TIME_T')
+				perl_ccflags += flag
+			endif
+		endforeach
+
+		if host_system == 'windows'
+			perl_ccflags += ['-DPLPERL_HAVE_UID_GID']
+
+			if cc.get_id() == 'msvc'
+				# prevent binary mismatch between MSVC built plperl and Strawberry or
+				# msys ucrt perl libraries
+				perl_v = run_command(perl, '-V', check: false).stdout()
+				if not perl_v.contains('USE_THREAD_SAFE_LOCALE')
+					perl_ccflags += ['-DNO_THREAD_SAFE_LOCALE']
+				endif
+			endif
+		endif
+
+		message('CCFLAGS recommended by perl: @0@'.format(perl_ccflags_r))
+		message('CCFLAGS for embedding perl: @0@'.format(' '.join(perl_ccflags)))
+
+		# We are after Embed's ldopts, but without the subset mentioned in
+		# Config's ccdlflags and ldflags.  (Those are the choices of those who
+		# built the Perl installation, which are not necessarily appropriate
+		# for building PostgreSQL.)
+		perl_ldopts = run_command(perl, '-e', '''
 use ExtUtils::Embed;
 use Text::ParseWords;
 # tell perl to suppress including these in ldopts
@@ -1273,20 +1273,20 @@ use Text::ParseWords;
 (my $opts = ldopts(undef)) =~ s!\\!\\\\!g;
 print "$_\n" foreach shellwords($opts);
 ''',
-     check: true).stdout().strip().split('\n')
+		 check: true).stdout().strip().split('\n')
 
-    message('LDFLAGS for embedding perl: "@0@"'.format(' '.join(perl_ldopts)))
+		message('LDFLAGS for embedding perl: "@0@"'.format(' '.join(perl_ldopts)))
 
-    perl_dep_int = declare_dependency(
-      compile_args: perl_ccflags,
-      link_args: perl_ldopts,
-      version: perlversion,
-    )
+		perl_dep_int = declare_dependency(
+			compile_args: perl_ccflags,
+			link_args: perl_ldopts,
+			version: perlversion,
+		)
 
-    # While we're at it, check that we can link to libperl.
-    # On most platforms, if perl.h is there then libperl.so will be too, but
-    # at this writing Debian packages them separately.
-    perl_link_test = '''
+		# While we're at it, check that we can link to libperl.
+		# On most platforms, if perl.h is there then libperl.so will be too, but
+		# at this writing Debian packages them separately.
+		perl_link_test = '''
 /* see plperl.h */
 #ifdef _MSC_VER
 #define __inline__ inline
@@ -1297,24 +1297,24 @@ int main(void)
 {
 perl_alloc();
 }'''
-    if not cc.links(perl_link_test, name: 'libperl',
-          args: test_c_args + perl_ccflags + perl_ldopts,
-          include_directories: postgres_inc)
-      perl_may_work = false
-      perl_msg = 'missing libperl'
-    endif
+		if not cc.links(perl_link_test, name: 'libperl',
+					args: test_c_args + perl_ccflags + perl_ldopts,
+					include_directories: postgres_inc)
+			perl_may_work = false
+			perl_msg = 'missing libperl'
+		endif
 
-  endif # perl_may_work
+	endif # perl_may_work
 
-  if perl_may_work
-    perl_dep = perl_dep_int
-  else
-    if perlopt.enabled()
-      error('dependency plperl failed: @0@'.format(perl_msg))
-    else
-      message('disabling optional dependency plperl: @0@'.format(perl_msg))
-    endif
-  endif
+	if perl_may_work
+		perl_dep = perl_dep_int
+	else
+		if perlopt.enabled()
+			error('dependency plperl failed: @0@'.format(perl_msg))
+		else
+			message('disabling optional dependency plperl: @0@'.format(perl_msg))
+		endif
+	endif
 endif
 
 
@@ -1326,15 +1326,15 @@ endif
 pyopt = get_option('plpython')
 python3_dep = not_found_dep
 if not pyopt.disabled()
-  pm = import('python')
-  python3_inst = pm.find_installation(python.full_path(), required: pyopt)
-  if python3_inst.found()
-    python3_dep = python3_inst.dependency(embed: true, required: pyopt)
-    # Remove this check after we depend on Meson >= 1.1.0
-    if not cc.check_header('Python.h', dependencies: python3_dep, required: pyopt, include_directories: postgres_inc)
-      python3_dep = not_found_dep
-    endif
-  endif
+	pm = import('python')
+	python3_inst = pm.find_installation(python.full_path(), required: pyopt)
+	if python3_inst.found()
+		python3_dep = python3_inst.dependency(embed: true, required: pyopt)
+		# Remove this check after we depend on Meson >= 1.1.0
+		if not cc.check_header('Python.h', dependencies: python3_dep, required: pyopt, include_directories: postgres_inc)
+			python3_dep = not_found_dep
+		endif
+	endif
 endif
 
 
